import sys
sys.path.append("../")
sys.path.append("../../")
from ffc.compiler.compiler import *

name = "Poisson"

a = None
L = None
    
dx = Integral("interior")
ds = Integral("boundary")

i = Index()
j = Index()
k = Index()
l = Index()
m = Index()
n = Index()

# Copyright (c) 2004 Anders Logg (logg@tti-c.org)
# Licensed under the GNU GPL Version 2
#
# The bilinear form a(u,v) and linear form L(v) for
# Poisson's equation.
#
# Compile this form with FFC: ffc Poisson.form

element = FiniteElement("Lagrange", "triangle", 1)

v = BasisFunction(element)
u = BasisFunction(element)
f = Function(element)

a = v.dx(i)*u.dx(i)*dx
L = v*f*dx

compile([a, L], name, "C++", "GNU GPL Version 2")
